package ru.dbotthepony.mc.otm.storage

import net.minecraft.world.item.Item
import net.minecraft.world.item.ItemStack
import net.minecraftforge.registries.ForgeRegistries
import net.minecraftforge.registries.ForgeRegistry
import ru.dbotthepony.mc.otm.core.ImpreciseFraction

class ItemStackWrapper(val stack: ItemStack) : IStorageStack {
	operator fun component1() = stack

	override fun copy(): IStorageStack {
		return ItemStackWrapper(stack.copy())
	}

	fun setCount(value: Int) {
		stack.count = value.coerceAtLeast(0)
	}

	override var count: ImpreciseFraction
		get() = ImpreciseFraction(stack.count)
		set(value) = setCount(value.toInt())

	override val maxStackSize get() = ImpreciseFraction(stack.maxStackSize)

	override val isEmpty: Boolean = stack.isEmpty
	override val partitionKey: Long = partitionKey(stack.item)

	override fun sameItem(other: IStorageStack): Boolean {
		if (this === other)
			return true

		if (other is ItemStackWrapper)
			return ItemStack.isSameItemSameTags(stack, other.stack)

		return false
	}

	companion object {
		@JvmField
		val EMPTY = ItemStackWrapper(ItemStack.EMPTY)

		fun partitionKey(item: Item) = (ForgeRegistries.ITEMS as ForgeRegistry<Item>?)?.getID(item)?.toLong() ?: System.identityHashCode(item).toLong()
	}
}
